### Virtual Method

# Gio File make_directory

#### Declaration

    gboolean
    make_directory (
      GFile* file,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Creates a directory. Note that this will only create a child directory of the immediate parent directory of the path or URI given by the `GFile`. To recursively create directories, see g_file_make_directory_with_parents(). This function will fail if the parent directory does not exist, setting `error` to `G_IO_ERROR_NOT_FOUND`. If the file system doesn’t support creating directories, this function will fail, setting `error` to `G_IO_ERROR_NOT_SUPPORTED`.

For a local `GFile` the newly created directory will have the default (current) ownership and permissions of the current process.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

#### Parameters

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on successful creation, `FALSE` otherwise.